<?php
/**
 * Created by PhpStorm.
 * User: rafaelrapalo
 * Date: 26/05/14
 * Time: 10:46
 */

namespace Service;


class AssetType {

    private $environmentService;
    private $entityManager;

    public function __construct( \Doctrine\ORM\EntityManager $entityManager,\Util\Utilities $environmentService){
        $this->environmentService = $environmentService;
        $this->entityManager = $entityManager;
    }
    function validParameters($param){
        if(!empty($param)){
            if(empty($param['id'])){
                $param['id'] = null;
            }
            if(empty($param['name'])){
                $param['name'] = null;
            }
        }
        return $param;
    }

    function createAssetType($param){
        $param = $this->validParameters($param);
        $FactoryAssetType = new \Factory\AssetType($this->environmentService);
        $entity = $FactoryAssetType->createAssetType($param['name']);
        $this->entityManager->persist($entity);
        $this->entityManager->flush();
        return $entity;
    }

    function getAssetType($param){
        $param = $this->validParameters($param);
        $RepositoryAssetType = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\AssetType');
        $entity = $RepositoryAssetType->getAssetType($param['id'], $param['name'],$this->environmentService->getOrganization()->getId());
        return $entity;
    }

    function deleteAssetType($param){
        $param = $this->validParameters($param);
        $RepositoryAssetType = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\AssetType');
        $entity = $RepositoryAssetType->getAssetType($param['id'], $param['name'],$this->environmentService->getOrganization()->getId());
        $this->entityManager->remove($entity[0]);
        $this->entityManager->flush();
    }

    function updateAssetType($param){
        $param = $this->validParameters($param);
        $RepositoryAssetType = $this->entityManager->getRepository('\Zeedhi\DevOps\Model\Projectmanagement\Entities\AssetType');
        $entity = $RepositoryAssetType->getAssetType($param['id'], null,$this->environmentService->getOrganization()->getId());
        $FactoryAssetType = new \Factory\AssetType($this->environmentService);
        $entity = $FactoryAssetType->updateAssetType($entity[0],$param['name']);
        $this->entityManager->persist($entity);
        $this->entityManager->flush();
        return $entity;
    }

} 